﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;


using CommonMP.HYSSOP.Interface.HSData;
using CommonMP.HYSSOP.Interface.HSViewer;
using CommonMP.HYSSOP.CoreImpl.HSData;
using CommonMP.HYSSOP.CoreImpl.HSTools;

using CommonMP.HYMCO.Interface.Model;
using CommonMP.HYMCO.Interface.Data;
using CommonMP.HYMCO.Interface.Controller;

using CommonMP.HYMCO.CoreImpl.Data;
using CommonMP.HYMCO.Ocean.McOceanBaseModel;

namespace CommonMP.HYMCO.Ocean.McOceanSampleModels
{
    /// <summary><para>class outline:</para>
    /// <para> 海洋開発洋上施設 モデル内演算中データクラス</para>
    /// </summary>
    /// <remarks><para>history:</para>
    /// <para>[2021/12/31][新規作成]</para>
    /// <para>remarks</para>
    /// <para>演算中の状態、初期条件等を保持するデータクラス</para>
    /// </remarks>
    [Serializable]
    public  class MzOceanHmnFacilityCalInfo : MzOceanHumanActCalInfo
    {
        ///// <summary> 捕獲要求漁獲量（総量） </summary>
        //public double m_TotalReqFishMass = 0.0;
        ///// <summary> 各レイヤーからの漁獲量  [ｔ] </summary>
        //public double[] m_CatchFishMass = null;

        //-----------------
        /// <summary>
        /// 
        /// </summary>
        public MzOceanHmnFacilityCalInfo()
        {
        }

        public override void SetLayerNum(long iLayerNum)
        {
            base.SetLayerNum(iLayerNum);
            //m_CatchFishMass = new double[m_lLayerNumber];
            //for( int ll=0;ll<m_lLayerNumber;ll++)
            //{
            //    m_CatchFishMass[ll] = 0.0;
            //}
        }

        public override void Clear()
        {
            base.Clear();
            //for (int ll = 0; ll < m_lLayerNumber; ll++)
            //{
            //    m_CatchFishMass[ll] = 0.0;
            //}
            m_dNowUnitCost = 0.001;
            m_dNowDealingChash = 0;
            m_dNextDealingChash = 0;
            m_dFeedCapability = 0;
        }

        /// <summary><para>method outline:</para>
        /// <para>自己複製</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> Clone( ) </para>
        /// </example>
        /// <param name="">無し</param>
        /// <returns>同一内容で　別院スタンス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>収束演算時、特定の時刻に状態を戻す場合等に使用する</para>
        /// </remarks>
        public override McCalInfo Clone()
        {
            MzOceanHmnFacilityCalInfo csRtn = new MzOceanHmnFacilityCalInfo();
            csRtn.CopyInfo(this);
            return csRtn;
        }

        /// <summary><para>method outline:</para>
        /// <para>引数で与えられた情報を自分にコピーを行う</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> bool bRtn = CopyInfo(csOrgInfo) </para>
        /// </example>
        /// <param name="csOrgInfo">コピー元情報</param>
        /// <returns> bool true :正常 , false:異常</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public override bool CopyInfo(McCalInfo csOrgInfo)
        {
            base.CopyInfo(csOrgInfo);
            MzOceanHmnFacilityCalInfo csOrgDt = (MzOceanHmnFacilityCalInfo)csOrgInfo;
            //m_CatchFishMass = new double[m_lLayerNumber];
            //for (int ll = 0; ll < m_lLayerNumber; ll++)
            //{
            //    m_CatchFishMass[ll] = csOrgDt.m_CatchFishMass[ll];
            //}
            m_dNowUnitCost = csOrgDt.m_dNowUnitCost;
            m_dNowDealingChash = csOrgDt.m_dNowDealingChash;
            m_dNextDealingChash = csOrgDt.m_dNextDealingChash;
            m_dFeedCapability = csOrgDt.m_dFeedCapability;

            return true;
        }


    }
}
